#include "stdafx.h"
#include <windows.h>
#include <windef.h>
#include <string.h>

#define DEMO

#ifndef DEMO
#include "MonMalloc.h"
#else
#include "dMonMalloc.h"
#endif
#define BUF_SIZE 256
char szName1[]="Global\\MyFMObject1";
char szFName1[]=".\\tempFile.map";
class CName {
public:
   enum {
      sizeOfBuffer = 256
   };

   char m_szFirst[sizeOfBuffer];
   char m_szLast[sizeOfBuffer];

public:

   void  SetName(char *pszFirst, char *pszLast) {
     strcpy_s(m_szFirst, sizeOfBuffer, pszFirst);
     strcpy_s(m_szLast, sizeOfBuffer, pszLast);
   }
  ~CName() { printf("");}
   CName() {printf("");}
   char *GetFirst() {return m_szFirst;}
   char *GetLast() {return m_szLast;}

};
class CNameBig:CName {
	int addt;
public:
	void SetAddt(int i) {addt = i;}
	int GetAddt() {return(addt);}
};
void test();

int _tmain(int argc, _TCHAR* argv[])
{
	if (OpenReport("Example.txt") == false) {
		printf("Could not open report file\n");
		return 1;
	}
	if (setTrace(true,"TExample.txt") == false) {
		printf("Could not open trace file\n");
		return 1;
	}
	test();
	getchar();
	return 0;
}
void test()
{
	void *t1,*t2,*t3;
	int *i1,i2;
	CName *Cptr;
	//CNameBig *CptrBig;
	char *nm;
	HANDLE hMapFile1;
	HANDLE hMapFile2;
	HANDLE hFile1;
	LPCTSTR pBuf1;
	LPCTSTR pBuf2;

	// malloc tests 
	PrintMode(true);
	t1 = malloc(100);
	free(t1); 
	free(t1);                          // BAD -> Produces error message-,standard lib crashes/assets
	t1 = malloc(110);
	delete t1;

	t1 = malloc(120);
	t2 = t1;
	t1 = realloc(t1, 130);
	free(t2);                                   // BAD -> MAY PRODUCE error message if t1 moves
	free(t1); 

	t1 = malloc(120);
	t2 = t1;
	free(t2);
	t1 = realloc(t1, 130);						// BAD -> produce error message
	free(t1);
//
	t1 = malloc(125);
	t1 = realloc(t1, 115);
	free(t1);
	t1 = malloc(120);
	t1 = realloc(t1, 120);
	delete t1;
	t1 = malloc(100);
	t2 = realloc(t1,110);
	t3 = realloc(t2,100);
	t3 = realloc(t2,110);
	// next statement is an error should be free(t3)
	// howevevr address did not change so no error produced (t1 is still equal to t3)
	free(t1);                     

	Cptr = (CName *) malloc(sizeof(CName)); 
	Cptr -> SetName("ABC", "123");
	nm = Cptr->GetFirst();
	delete Cptr;
	Cptr = (CName *) malloc(sizeof(CName)); 
	Cptr -> SetName("ABC", "123");
	free(Cptr);

	free(t2);    // BAD
	free(t3);   // BAD

	// calloc tests
	t1 = calloc(100,1);
	free(t1);
	t1 = calloc(110,2);
	delete t1;
	t1 = calloc(120,4);
	t1 = realloc(t1, 600);
	free(t1);
	t1 = calloc(125,2);
	t1 = realloc(t1, 115);
	free(t1);
	t1 = calloc(60,2);
	t1 = realloc(t1, 120);
	free(t1);

	// new of simple variable
	i1 = new int;
	delete i1;
	i1 = new int;
	free(i1);
	i1 = new int;
	*i1 = 100;
	i1 = (int *)realloc((void *) i1, 100);
	if (i1 != NULL) {
		i1[1] = 1;
		i1[2] = 2;
		i1[3] = 3;
		i2 = i1[0]+i1[1]+i1[2]+i1[3];
	}
	free(i1);

	// A class
	Cptr = new CName;
	Cptr -> SetName("ABC", "123");
	delete Cptr;
	Cptr = new CName;
	Cptr -> SetName("ABC", "123");
	free(Cptr);
	// Arrays of simple variables
	i1 = new int[100];
	delete [] i1;
	i1 = new int[101];
	i1[10] = 5;
	delete i1;
	i2 = i1[10];                       // i2 = invalid data
	i1 = new int[102];
	i1[10] = 5;
	i2 = i1[10];
	free(i1);
	i2 = i1[10];                       // i2 = invalid data
	//endFun();
	//PrintAll(true);
	hFile1 = CreateFile(szFName1, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	hMapFile1 = CreateFileMapping(hFile1,	NULL, PAGE_READWRITE, 0, BUF_SIZE, szName1);
	pBuf1 = (LPTSTR) MapViewOfFile(hMapFile1, FILE_MAP_ALL_ACCESS, 0, 0, BUF_SIZE);
	FlushViewOfFile(pBuf1,BUF_SIZE);
	UnmapViewOfFile(pBuf1);
	CloseHandle(hMapFile1);
	CloseHandle(hFile1);
	hMapFile2 = CreateFileMapping(INVALID_HANDLE_VALUE,	NULL, PAGE_READWRITE, 0, BUF_SIZE, szName1);
	pBuf2 = (LPTSTR) MapViewOfFile(hMapFile2, FILE_MAP_ALL_ACCESS, 0, 0, BUF_SIZE);
	CloseHandle(hMapFile2);
	FlushViewOfFile(pBuf2,BUF_SIZE);
	UnmapViewOfFile(pBuf2);
	PrintFullReport(true);
	NoEnd(true);
	return;
}

